## freefoam 0.1.0+dfsg

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8.2 FATAL_ERROR)

project(FreeFOAM)

string(TOLOWER "${PROJECT_NAME}" LOWER_PROJECT_NAME)

# version information
set(FOAM_VERSION_MAJOR 0)
set(FOAM_VERSION_MINOR 1)
set(FOAM_VERSION_PATCH 0)
set(FOAM_VERSION_SUFFIX)
set(FOAM_VERSION ${FOAM_VERSION_MAJOR}.${FOAM_VERSION_MINOR})
set(FOAM_VERSION_FULL
  ${FOAM_VERSION}.${FOAM_VERSION_PATCH}${FOAM_VERSION_SUFFIX})
set(FOAM_SOVERSION 1)
set(FOAM_UPSTREAM_VERSION_FULL 1.7.x-d08d3c2)

# set up custom cmake module path
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake/Modules)

# utilities
set(FOAM_CREATE_INCLUDE_WRAPPERS TRUE)
set(FOAM_HAS_FLEX_SOURCES TRUE)
set(FOAM_ENABLE_DOC_INDEX TRUE)
set(FOAM_EXPORT_NAMESPACE FOAM_)
include(${CMAKE_SOURCE_DIR}/CMake/FOAMUtilities.cmake)
include(${CMAKE_SOURCE_DIR}/CMake/FOAMThirdPartyUtilities.cmake)
include(${CMAKE_SOURCE_DIR}/CMake/FOAMInternal.cmake)
include(CTest)

# determine computer system
include(${CMAKE_SOURCE_DIR}/CMake/FOAMDetermineArch.cmake)

# select precision
foam_option(FOAM_DOUBLE_PRECISION "Double precision"
  "Compile ${PROJECT_NAME} with double precision floating point arithmetics."
  ON)
mark_as_advanced(FOAM_DOUBLE_PRECISION)
if(FOAM_DOUBLE_PRECISION)
  set(FOAM_PRECISION DP)
else()
  set(FOAM_PRECISION SP)
endif()

# select whether we want to build framewors on Mac OS X
if(APPLE)
  foam_option(FOAM_BUILD_FRAMEWORKS "Build frameworks"
    "Build frameworks on Mac OS X" OFF)
  mark_as_advanced(FOAM_BUILD_FRAMEWORKS)
else()
  set(FOAM_BUILD_FRAMEWORKS OFF)
endif()

# find python interpreter
find_package(PythonInterp REQUIRED)

# make sure we got Python version 2.4 or newer
foam_dependent_variables(PYTHON_EXECUTABLE PYTHON_VERSION)
if(NOT PYTHON_VERSION)
  foam_determine_python_version(PYTHON_VERSION ${PYTHON_EXECUTABLE})
  set(PYTHON_VERSION ${PYTHON_VERSION} CACHE INTERNAL "The Python version")
  if(PYTHON_VERSION VERSION_LESS 2.4.0)
    message(SEND_ERROR
      "Python version 2.4 or newer required (PYTHON_EXECUTABLE)")
  endif()
endif()
string(REGEX REPLACE "\\.[0-9]+$" "" PYTHON_SHORT_VERSION ${PYTHON_VERSION})

# find the installed ParaView executable
find_program(
  FOAM_PARAVIEW3_APP NAMES "ParaView 3.12.0" "ParaView 3.10.1"
  "ParaView 3.10.0" "ParaView 3.8.1" "ParaView 3.8.0" ParaView paraview
  DOC "Path to the ParaView 3.8 (or newer) application")
mark_as_advanced(FOAM_PARAVIEW3_APP)
foam_dependent_variables(FOAM_PARAVIEW3_APP FOAM_PARAVIEW3_VERSION)
if(FOAM_PARAVIEW3_APP)
  if(NOT FOAM_PARAVIEW3_VERSION)
    get_filename_component(_FOAM_PV3_BINDIR ${FOAM_PARAVIEW3_APP} PATH)
    set(_FOAM_PVBATCH_EXECUTABLE ${_FOAM_PV3_BINDIR}/pvbatch)
    if(NOT EXISTS ${_FOAM_PVBATCH_EXECUTABLE})
      set(_FOAM_PVBATCH_EXECUTABLE ${FOAM_PARAVIEW3_APP})
    endif()
    execute_process(COMMAND ${_FOAM_PVBATCH_EXECUTABLE} --version
      OUTPUT_VARIABLE _pv_version_output
      ERROR_VARIABLE _pv_version_output
      OUTPUT_STRIP_TRAILING_WHITESPACE
      )
    if(_pv_version_output MATCHES
        "(paraview version |ParaView)(([0-9]+\\.)+[0-9]+)")
      set(FOAM_PARAVIEW3_VERSION ${CMAKE_MATCH_2} CACHE INTERNAL
        "The ParaView version")
      message(STATUS
        "ParaView ${FOAM_PARAVIEW3_VERSION} found: ${FOAM_PARAVIEW3_APP}")
    else()
      message(SEND_ERROR
        "Failed to determine the ParaView version: ${_pv_version_output}")
    endif()
  endif()
  if(${FOAM_PARAVIEW3_VERSION} VERSION_LESS 3.8)
    message(WARNING
      "ParaView versions older than 3.8 might not be able\n"
      "to read ${PROJECT_NAME} cases.")
  endif()
else()
  message(WARNING
    "Failed to find the ParaView application")
  set(FOAM_PARAVIEW3_APP)
endif()

# we want shared libraries
set(BUILD_SHARED_LIBS SHARED)

# installation directories
foam_installation_path(FOAM_INSTALL_BIN_PATH bin "Executables"
  "Executables installation path")
if(APPLE AND FOAM_BUILD_FRAMEWORKS)
  foam_installation_path(FOAM_INSTALL_FRAMEWORK_PATH /Library/Frameworks
    "Frameworks" "Framework installation path")
endif()
foam_installation_path(FOAM_INSTALL_LIBRARY_PATH
  lib/${CMAKE_PROJECT_NAME}-${FOAM_VERSION_FULL}
  "Libraries" "Library installation path")
if(NOT WIN32)
  foam_installation_path(FOAM_INSTALL_PLUGIN_PATH
    "${FOAM_INSTALL_LIBRARY_PATH_ORIG}/plugins${FOAM_SOVERSION}"
    "Plugins" "Plugin installation path")
endif()
foam_installation_path(FOAM_INSTALL_LIBEXEC_PATH
  libexec/${CMAKE_PROJECT_NAME}-${FOAM_VERSION_FULL} "Private executables"
  "Installation path for executables not on PATH.")
foam_installation_path(FOAM_INSTALL_HEADER_PATH
  include/${CMAKE_PROJECT_NAME}-${FOAM_VERSION_FULL}
  "Headers" "Header installation path (not for frameworks)")
foam_installation_path(FOAM_INSTALL_CONFIG_PATH
  etc/${CMAKE_PROJECT_NAME}/${FOAM_VERSION_FULL} "Config files"
  "Configuration files installation path")
foam_installation_path(FOAM_INSTALL_DATA_PATH
  share/${CMAKE_PROJECT_NAME}-${FOAM_VERSION_FULL} "Data files"
  "Data files installation path")
foam_installation_path(FOAM_INSTALL_DOC_PATH
  share/doc/${CMAKE_PROJECT_NAME}-${FOAM_VERSION_FULL} "Documentation"
  "Documentation files installation path")
foam_installation_path(FOAM_INSTALL_MAN_PATH share/man "Man pages"
  "Man-pages installation path")
foam_installation_path(FOAM_INSTALL_TUTORIALS_PATH
  "${FOAM_INSTALL_DOC_PATH_ORIG}" "Tutorials" "Tutorials installation path")
foam_installation_path(FOAM_INSTALL_CMAKE_PATH
  "${FOAM_INSTALL_DATA_PATH_ORIG}/CMake"
  "CMake files" "CMake configuration files installation path")
foam_installation_path(FOAM_INSTALL_USERDFOAM_PATH
  "${FOAM_INSTALL_PLUGIN_PATH_ORIG}/ensightReader"
  "Ensight plugin" "Ensight OpenFOAM-reader plugin installation path")
foam_dependent_variables(PYTHON_VERSION FOAM_INSTALL_PYTHON_PATH)
foam_installation_path(FOAM_INSTALL_PYTHON_PATH
  "lib/python${PYTHON_SHORT_VERSION}/site-packages"
  "Python modules" "Python modules installation base path")

set(FOAM_INSTALL_RUNTIME_PATH "${FOAM_INSTALL_LIBEXEC_PATH}")

# determine the INSTALL_NAME_DIR of potential frameworks
if(APPLE AND FOAM_BUILD_FRAMEWORKS)
  set(FOAM_FRAMEWORK_INSTALL_NAME_DIR "${FOAM_INSTALL_FRAMEWORK_PATH}")
else()
  set(FOAM_FRAMEWORK_INSTALL_NAME_DIR "${FOAM_INSTALL_LIBRARY_PATH}")
endif()

# select html documentation browser (try a few well known ones for default)
# have to loop, because find_program(HTML_DOC_BROWSER NAMES ...) garbles things
# up
set(_BROWSERS xdg-open sensible-browser x-www-browser gnome-open kde-open
  firefox chromium-browser epiphany konqueror www-browser w3m lynx launch)
if(APPLE)
  list(INSERT _BROWSERS 0 open)
endif()
foreach(browser IN LISTS _BROWSERS)
  find_program(HTML_DOC_BROWSER ${browser}
    DOC "Program to open an HTML file")
  if(HTML_DOC_BROWSER)
    break()
  endif()
endforeach()
if(NOT HTML_DOC_BROWSER)
  message(STATUS
    "Failed to find a program to open HTML pages with (a.k.a a browser).\n"
    "Point HTML_DOC_BROWSER to a suitable program.")
  set(HTML_DOC_BROWSER "ECHO" CACHE STRING
    "Command to open an HTML file (ECHO will print it to STDOUT)" FORCE)
endif()
set(FOAM_HTML_DOC_BROWSER_COMMAND
  "\${HTML_DOC_BROWSER} %f" CACHE STRING "Command to open an HTML file")
string(CONFIGURE "${FOAM_HTML_DOC_BROWSER_COMMAND}"
  FOAM_HTML_DOC_BROWSER_COMMAND ESCAPE_QUOTES)
mark_as_advanced(HTML_DOC_BROWSER FOAM_HTML_DOC_BROWSER_COMMAND)

# Executable-prefix
string(TOLOWER "${PROJECT_NAME}-" _FOAM_DEFAULT_EXE_PREFIX)
set(FOAM_EXE_PREFIX "${_FOAM_DEFAULT_EXE_PREFIX}"
  CACHE STRING "Prefix for application output-names")
mark_as_advanced(FOAM_EXE_PREFIX)
string(TOUPPER "${FOAM_EXE_PREFIX}" FOAM_UPPER_EXE_PREFIX)

# ask user whether she wants to build Doxygen docs
foam_option(FOAM_ENABLE_DOXYGEN_DOCS "Doxygen API documentation"
  "Build the Doxygen API documentation" OFF)
# make sure only ON and OFF are used
if(FOAM_ENABLE_DOXYGEN_DOCS)
  set(FOAM_ENABLE_DOXYGEN_DOCS ON)
else()
  set(FOAM_ENABLE_DOXYGEN_DOCS OFF)
endif()
# if user wants doxygen docs, find Doxygen and set up some options
if(FOAM_ENABLE_DOXYGEN_DOCS)
  find_package(Doxygen REQUIRED)
  execute_process(COMMAND ${DOXYGEN_EXECUTABLE} --version
    RESULT_VARIABLE DOXYGEN_VERSION_RESULT
    OUTPUT_VARIABLE DOXYGEN_VERSION_OUTPUT
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(DOXYGEN_VERSION_RESULT)
    message(SEND_ERROR "Failed to determine doxygen version")
  endif()
  if(${DOXYGEN_VERSION_OUTPUT} VERSION_GREATER 1.6.3 AND
      ${DOXYGEN_VERSION_OUTPUT} VERSION_LESS 1.7.2-20101106)
    message(WARNING
      "Found Doxygen version ${DOXYGEN_VERSION_OUTPUT}. "
      "Versions newer than 1.6.3 and older than 1.7.2-20101106 "
      "usually crash when processing the ${PROJECT_NAME} documentation.")
  endif()
  # ask user whether she prefers local or www docs
  foam_option(FOAM_USE_LOCAL_DOXYGEN_DOCS "Use local API docs"
    "Use the local API documentation instead of http://freefoam.sf.net/doc/API"
    ON)
  mark_as_advanced(FOAM_USE_LOCAL_DOXYGEN_DOCS)
endif()

# ask user whether she wants to build the man pages
foam_option(FOAM_ENABLE_MANPAGE_HELP "Build manpage help"
  "Build the manpages (requires asciidoc)" OFF)
# ask user whether she wants to build the xhtml man pages
foam_option(FOAM_ENABLE_XHTML_HELP "Build xhtml help"
  "Build the xhtml help pages (requires asciidoc)" OFF)
# as user whether she wanst to build the xhtml guides
foam_option(FOAM_ENABLE_XHTML_GUIDES "Build the xhtml guides"
  "Build the xhtml guides (requires asciidoc, dot, inkscape and asymptote)"
  OFF)
# as user whether she wanst to build the xhtml guides
foam_option(FOAM_ENABLE_PDF_GUIDES "Build the PDF guides"
  "Build the PDF guides (requires asciidoc, dot, inkscape and asymptote)" OFF)
if(FOAM_ENABLE_PDF_GUIDES)
  foam_option(FOAM_USE_FOP "Use FOP instead of dblatex"
    "Use FOP to build the PDF guides instead of dblatex" OFF)
  mark_as_advanced(FOAM_USE_FOP)
else()
  set(FOAM_USE_FOP FALSE)
endif()

if(FOAM_ENABLE_DOXYGEN_DOCS OR FOAM_ENABLE_XHTML_GUIDES)
  foam_option(FOAM_DOCS_FOR_SF "Docs for SourceForge"
    "Build the docs for deployment on SourceForge" OFF)
  mark_as_advanced(FOAM_DOCS_FOR_SF)
  # make sure only ON and OFF are used
  if(FOAM_DOCS_FOR_SF)
    set(FOAM_DOCS_FOR_SF ON)
  else()
    set(FOAM_DOCS_FOR_SF OFF)
  endif()
endif()

if(BUILD_TESTING)
  # ask user whether whe wants full tutorial tests
  foam_option(FOAM_ENABLE_FULL_TUTORIAL_TESTS
    "Full tutorial tests"
    "Run the complete tutorial tests (not just a single time step)" OFF)
  mark_as_advanced(FOAM_ENABLE_FULL_TUTORIAL_TESTS)

=== applications/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

add_subdirectory(solvers)
add_subdirectory(utilities)
#add_subdirectory(test)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== bin/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

# make sure that .py.in is stripped on non-Windows platforms
if(NOT WIN32)
  set(FOAM_STRIP_SUFFIXES "\\.py$" "\\.in$")
endif()

# configure the freefoam script for build and install tree
foam_configure_files(installFreefoam
  DESTDIR bin
  "freefoam.py.in==${LOWER_PROJECT_NAME}.py"
  )

# configure the utility scripts for build tree and the install tree
foam_configure_files(installScripts
  DESTDIR libexec/FreeFOAM/${FOAM_VERSION_FULL}
  "freefoam-clearPolyMesh.py.in==${FOAM_EXE_PREFIX}clearPolyMesh.py"
  "freefoam-copySettings.py.in==${FOAM_EXE_PREFIX}copySettings.py"
  "freefoam-graphExecTime.py.in==${FOAM_EXE_PREFIX}graphExecTime.py"
  "freefoam-graphResKE.py.in==${FOAM_EXE_PREFIX}graphResKE.py"
  "freefoam-graphResUVWP.py.in==${FOAM_EXE_PREFIX}graphResUVWP.py"
  "freefoam-job.py.in==${FOAM_EXE_PREFIX}job.py"
  "freefoam-log.py.in==${FOAM_EXE_PREFIX}log.py"
  "freefoam-solverSweeps.py.in==${FOAM_EXE_PREFIX}solverSweeps.py"
  )

foam_configure_files(installPFScript
  DESTDIR libexec/FreeFOAM/${FOAM_VERSION_FULL}
  "freefoam-para.py.in==${FOAM_EXE_PREFIX}para.py"
  )
list(APPEND buildScripts ${buildPFScript})
list(APPEND installScripts ${installPFScript})

# install the scripts
install(PROGRAMS
  ${installFreefoam}
  DESTINATION ${FOAM_INSTALL_BIN_PATH}
  COMPONENT bin
  )

install(PROGRAMS
  ${installScripts}
  DESTINATION ${FOAM_INSTALL_LIBEXEC_PATH}
  COMPONENT bin
  )

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== data/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

# configure the utility data files for build tree and the install tree
foam_configure_files(installDataFiles
  DESTDIR data
  COPYONLY
  foamLog.db
  templates/foamAppTemplate.C
  templates/foamCommentStyles
  templates/foamScript
  templates/foamTemplate.C
  templates/foamTemplate.H
  templates/foamTemplateI.H
  templates/foamTemplateIO.C
  templates/foamTemplateTemplate.C
  templates/foamTemplateTemplate.H
  templates/foamTemplateTemplateI.H
  templates/foamTemplateTemplateIO.C
  )

# install the data files
foam_install_configured_files(FILES
  ${installDataFiles}
  DESTINATION ${FOAM_INSTALL_DATA_PATH}
  COMPONENT data
  )

add_subdirectory(asciidoc)
add_subdirectory(utilities)
add_subdirectory(python/FreeFOAM)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== doc/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

if(FOAM_ENABLE_XHTML_HELP OR FOAM_ENABLE_DOXYGEN_DOCS
    OR FOAM_ENABLE_XHTML_GUIDES)
  foam_configure_files(installImgFiles
    COPYONLY
    DESTDIR doc/html
    img/FreeFOAMLogo.png
    img/CrossPlatformToolkit.png)

  install(FILES
    ${installImgFiles}
    DESTINATION ${FOAM_INSTALL_DOC_PATH}/img COMPONENT doc)

  foam_configure_files(installCSSFiles
    COPYONLY
    DESTDIR doc/html
    css/layout.css
    css/custom.css)
  if(FOAM_ENABLE_XHTML_HELP OR FOAM_ENABLE_XHTML_GUIDES)
    # have asciidoc, use xhtml11.css and asciidoc-xhtml12.js from there
    if(EXISTS "${A2X_CONF_DIR}/stylesheets/xhtml11.css")
      configure_file("${A2X_CONF_DIR}/stylesheets/xhtml11.css"
        "${CMAKE_CURRENT_BINARY_DIR}/html/css/xhtml11.css" COPYONLY)
    elseif(EXISTS "${A2X_CONF_DIR}/stylesheets/asciidoc.css")
      # newer versions renamed xhtml11.css to asciidoc.css
      configure_file("${A2X_CONF_DIR}/stylesheets/asciidoc.css"
        "${CMAKE_CURRENT_BINARY_DIR}/html/css/xhtml11.css" COPYONLY)
    else()
      message(SEND_ERROR "Failed to find xhtml11.css or asciidoc.css")
    endif()
    configure_file("${A2X_CONF_DIR}/stylesheets/docbook-xsl.css"
      "${CMAKE_CURRENT_BINARY_DIR}/html/css/docbook-xsl.css" COPYONLY)
    set(installXHTMLCSSFiles
      "${CMAKE_CURRENT_BINARY_DIR}/html/css/xhtml11.css"
      "${CMAKE_CURRENT_BINARY_DIR}/html/css/docbook-xsl.css")
    if(EXISTS "${A2X_CONF_DIR}/javascripts/asciidoc-xhtml11.js")
      configure_file("${A2X_CONF_DIR}/javascripts/asciidoc-xhtml11.js"
        "${CMAKE_CURRENT_BINARY_DIR}/html/js/asciidoc-xhtml11.js" COPYONLY)
    elseif(EXISTS "${A2X_CONF_DIR}/javascripts/asciidoc.js")
      # newer versions renamed asciidoc-xhtml11.js to asciidoc.js
      configure_file("${A2X_CONF_DIR}/javascripts/asciidoc.js"
        "${CMAKE_CURRENT_BINARY_DIR}/html/js/asciidoc-xhtml11.js" COPYONLY)
    else()
      message(SEND_ERROR "Failed to find asciidoc-xhtml11.js or asciidoc.js")
    endif()
    set(installXHTMLJavaScriptFiles
      "${CMAKE_CURRENT_BINARY_DIR}/html/js/asciidoc-xhtml11.js")
    install(FILES ${installXHTMLJavaScriptFiles}
      DESTINATION  ${FOAM_INSTALL_DOC_PATH}/js COMPONENT doc)
  else()
    # otherwise use our own
    foam_configure_files(installXHTMLCSSFiles
      COPYONLY
      DESTDIR doc/html
      css/xhtml11.css)
  endif()

  install(FILES ${installCSSFiles} ${installXHTMLCSSFiles}
    DESTINATION ${FOAM_INSTALL_DOC_PATH}/css COMPONENT doc)
endif()

if(FOAM_ENABLE_XHTML_HELP OR FOAM_ENABLE_XHTML_GUIDES)
  set(opts
    -f "${CMAKE_BINARY_DIR}/data/asciidoc/html.conf"
    -a toc
    -a linkcss
    -a "data-uri!"
    -a stylesdir=css
    -a foam-stylesdir=css
    -a scriptsdir=js
    -a foam-scriptsdir=js
    -a imagesdir=img
    -a rel-doc=.
    -a docs-only)
  if(FOAM_DOCS_FOR_SF)
    list(APPEND opts -a foam-doc-for_sf)
  endif()
  if(FOAM_ENABLE_XHTML_GUIDES)
    list(APPEND opts -a foam-have-ug)
  endif()
  if(FOAM_ENABLE_XHTML_HELP)
    list(APPEND opts -a foam-have-man)
  endif()
  if(FOAM_ENABLE_DOXYGEN_DOCS)
    list(APPEND opts -a foam-have-doxy)
  endif()
  set(pkgdocs)
  foreach(f ChangeLog COPYING INSTALL README ReleaseNotes)
    set(o "${CMAKE_CURRENT_BINARY_DIR}/html/${f}.html")
    add_custom_command(OUTPUT "${o}"
      COMMAND ${PYTHON2_EXECUTABLE} ${ASCIIDOC_EXECUTABLE}
        ${opts} -o "${o}" "${CMAKE_SOURCE_DIR}/${f}"
      DEPENDS "${CMAKE_SOURCE_DIR}/${f}"
        "${CMAKE_BINARY_DIR}/data/asciidoc/html.conf"
      COMMENT "Generating ${f}.html"
      VERBATIM)
    list(APPEND pkgdocs "${o}")
  endforeach()
  add_custom_target(pkgdocs DEPENDS ${pkgdocs})
  add_dependencies(doc pkgdocs)
  install(FILES ${pkgdocs}
    DESTINATION ${FOAM_INSTALL_DOC_PATH} COMPONENT doc)
endif()

add_subdirectory(man/manSource)

if(FOAM_ENABLE_DOXYGEN_DOCS)
  add_subdirectory(Doxygen)
endif()

if(FOAM_ENABLE_XHTML_GUIDES AND FOAM_ENABLE_MATHJAX)
  configure_file(js/MathJaxMacros.js
    "${CMAKE_CURRENT_BINARY_DIR}/html/js/MathJaxMacros.js" COPYONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/html/js/MathJaxMacros.js"
    DESTINATION "${FOAM_INSTALL_DOC_PATH}/js" COMPONENT doc)
endif()

if(FOAM_GUIDES_FORMATS)
  add_subdirectory(UserGuide)
endif()

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== etc/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

# configure the utility config files for build tree and the install tree
foam_configure_files(installFiles
  DESTDIR etc
  controlDict.in

  COPYONLY
  cellModels
  )

foam_configure_files(installThermoDataFiles
  DESTDIR etc
  COPYONLY
  thermoData/BurcatCpData
  thermoData/therm.dat
  )

# install the config files
install(FILES ${installFiles}
  DESTINATION ${FOAM_INSTALL_CONFIG_PATH}
  COMPONENT config
  )
install(FILES ${installThermoDataFiles}
  DESTINATION ${FOAM_INSTALL_CONFIG_PATH}/thermoData
  COMPONENT config
  )

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== src/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

add_subdirectory(Pstream)
add_subdirectory(OSspecific)
add_subdirectory(OpenFOAM)
add_subdirectory(lagrangian)
add_subdirectory(triSurface)
add_subdirectory(edgeMesh)
add_subdirectory(meshTools)
add_subdirectory(finiteVolume)
add_subdirectory(genericPatchFields)
add_subdirectory(decompositionMethods)
add_subdirectory(sampling)
add_subdirectory(dynamicMesh)
add_subdirectory(dynamicFvMesh)
add_subdirectory(topoChangerFvMesh)
add_subdirectory(fvMotionSolver)
add_subdirectory(engine)
add_subdirectory(ODE)
add_subdirectory(randomProcesses)
add_subdirectory(thermophysicalModels)
add_subdirectory(transportModels)
add_subdirectory(turbulenceModels)
add_subdirectory(postProcessing)
add_subdirectory(conversion)
add_subdirectory(autoMesh)
add_subdirectory(errorEstimation)
foam_conditional_component(MGridGenGamgAgglomeration ${FOAM_ENABLE_MGRIDGEN}
  fvAgglomerationMethods/MGridGenGamgAgglomeration
  "FOAM_ENABLE_MGRIDGEN disabled")
add_subdirectory(surfMesh)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== tutorials/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

file(RELATIVE_PATH TUTORIAL_DIR ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

# make sure that the right suffixes get stripped
if(NOT WIN32)
  set(FOAM_STRIP_SUFFIXES "\\.py\\.in$" "\\.in$")
endif()

foam_configure_files(installScriptFiles
  DESTDIR ${TUTORIAL_DIR}
  Allrun.py.in
  )

foam_install_configured_files(PROGRAMS ${installScriptFiles}
  DESTINATION ${FOAM_INSTALL_TUTORIALS_PATH}
  COMPONENT tutorials
  )

add_subdirectory(DNS/dnsFoam)
add_subdirectory(basic/laplacianFoam)
add_subdirectory(basic/potentialFoam)
add_subdirectory(basic/scalarTransportFoam)
add_subdirectory(combustion/XiFoam)
add_subdirectory(combustion/dieselFoam)
add_subdirectory(combustion/engineFoam)
add_subdirectory(combustion/reactingFoam)
add_subdirectory(combustion/fireFoam)
add_subdirectory(compressible/rhoCentralFoam)
add_subdirectory(compressible/rhoPimpleFoam)
add_subdirectory(compressible/rhoPorousMRFPimpleFoam)
add_subdirectory(compressible/rhoPisoFoam)
add_subdirectory(compressible/rhoPorousSimpleFoam)
add_subdirectory(compressible/sonicFoam)
add_subdirectory(compressible/sonicLiquidFoam)
add_subdirectory(discreteMethods/dsmcFoam)
add_subdirectory(discreteMethods/molecularDynamics/mdEquilibrationFoam)
add_subdirectory(discreteMethods/molecularDynamics/mdFoam)
add_subdirectory(electromagnetics/electrostaticFoam)
add_subdirectory(electromagnetics/mhdFoam)
add_subdirectory(financial/financialFoam)
add_subdirectory(heatTransfer/buoyantPimpleFoam)
add_subdirectory(heatTransfer/buoyantSimpleFoam)
add_subdirectory(heatTransfer/buoyantSimpleRadiationFoam)
add_subdirectory(heatTransfer/buoyantBoussinesqPimpleFoam)
add_subdirectory(heatTransfer/buoyantBoussinesqSimpleFoam)
add_subdirectory(heatTransfer/chtMultiRegionFoam)
add_subdirectory(heatTransfer/chtMultiRegionSimpleFoam)
add_subdirectory(incompressible/MRFSimpleFoam)
add_subdirectory(incompressible/SRFPimpleFoam)
add_subdirectory(incompressible/boundaryFoam)
add_subdirectory(incompressible/channelFoam)
add_subdirectory(incompressible/icoFoam)
add_subdirectory(incompressible/nonNewtonianIcoFoam)
add_subdirectory(incompressible/pimpleFoam)
add_subdirectory(incompressible/pimpleDyMFoam)
add_subdirectory(incompressible/pisoFoam)
add_subdirectory(incompressible/shallowWaterFoam)
add_subdirectory(incompressible/simpleFoam)
add_subdirectory(incompressible/simpleSRFFoam)
add_subdirectory(incompressible/simpleWindFoam)
add_subdirectory(incompressible/porousSimpleFoam)
add_subdirectory(lagrangian/rhoPisoTwinParcelFoam)
add_subdirectory(lagrangian/coalChemistryFoam)
add_subdirectory(lagrangian/porousExplicitSourceReactingParcelFoam)
add_subdirectory(lagrangian/reactingParcelFoam)
add_subdirectory(mesh/moveDynamicMesh)
add_subdirectory(mesh/snappyHexMesh)
add_subdirectory(multiphase/MRFInterFoam)
add_subdirectory(multiphase/bubbleFoam)
add_subdirectory(multiphase/cavitatingFoam)
add_subdirectory(multiphase/compressibleInterFoam)
add_subdirectory(multiphase/interDyMFoam)
add_subdirectory(multiphase/interFoam)
add_subdirectory(multiphase/interPhaseChangeFoam)
add_subdirectory(multiphase/multiphaseInterFoam)
add_subdirectory(multiphase/MRFMultiphaseInterFoam)
add_subdirectory(multiphase/settlingFoam)
add_subdirectory(multiphase/twoPhaseEulerFoam)
add_subdirectory(multiphase/interMixingFoam)
add_subdirectory(stressAnalysis/solidDisplacementFoam)
add_subdirectory(stressAnalysis/solidEquilibriumDisplacementFoam)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== applications/solvers/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------


foam_add_app_section(sol_dns "== SOLVERS ==\n=== DNS ===")
set(FOAM_APP_SECTION sol_dns)
add_subdirectory(DNS)

foam_add_app_section(sol_basic "=== Basic Solvers ===")
set(FOAM_APP_SECTION sol_basic)
add_subdirectory(basic)

foam_add_app_section(sol_combustion "=== Combustion Solvers ===")
set(FOAM_APP_SECTION sol_combustion)
add_subdirectory(combustion)

foam_add_app_section(sol_compressible "=== Compressible Flow Solvers ===")
set(FOAM_APP_SECTION sol_compressible)
add_subdirectory(compressible)

foam_add_app_section(sol_electromag "=== Electromagnetic Solvers ===")
set(FOAM_APP_SECTION sol_electromag)
add_subdirectory(electromagnetics)

foam_add_app_section(sol_financial "=== Financial Solvers ===")
set(FOAM_APP_SECTION sol_financial)
add_subdirectory(financial)

foam_add_app_section(sol_heattran "=== Heat Transfer Solvers ===")
set(FOAM_APP_SECTION sol_heattran)
add_subdirectory(heatTransfer)

foam_add_app_section(sol_incompressible "=== Incompressible Flow Solvers ===")
set(FOAM_APP_SECTION sol_incompressible)
add_subdirectory(incompressible)

foam_add_app_section(sol_discrete "=== Discrete Methods Solvers ===")
set(FOAM_APP_SECTION sol_discrete)
add_subdirectory(discreteMethods)

foam_add_app_section(sol_lagrangian "=== Lagrangian Solvers ===")
set(FOAM_APP_SECTION sol_lagrangian)
add_subdirectory(lagrangian)

foam_add_app_section(sol_multiphase "=== Multiphase Solvers ===")
set(FOAM_APP_SECTION sol_multiphase)
add_subdirectory(multiphase)

foam_add_app_section(sol_stress "=== Stress-Analysis ===")
set(FOAM_APP_SECTION sol_stress)
add_subdirectory(stressAnalysis)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== applications/test/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

add_subdirectory(quaternion)
add_subdirectory(tmpField)
add_subdirectory(io)
add_subdirectory(dictionary)
add_subdirectory(SLList)
add_subdirectory(stringList)
add_subdirectory(symmTensorField)
add_subdirectory(ISLList)
add_subdirectory(error)
add_subdirectory(Dictionary_)
add_subdirectory(pointField)
add_subdirectory(maxMem)
add_subdirectory(DLList)
add_subdirectory(HashPtrTable)
add_subdirectory(dataEntry)
add_subdirectory(HashTable2)
add_subdirectory(Matrix)
add_subdirectory(Tuple2)
add_subdirectory(callback)
add_subdirectory(IndirectList)
add_subdirectory(graphXi)
add_subdirectory(primitivePatch)
add_subdirectory(tensor)
add_subdirectory(POSIX)
add_subdirectory(alloc)
add_subdirectory(sphericalTensorField)
add_subdirectory(vector)
add_subdirectory(volPointInterpolation)
add_subdirectory(string)
add_subdirectory(findCell-octree)
add_subdirectory(pTraits)
add_subdirectory(liquid)
add_subdirectory(List)
add_subdirectory(triTet)
add_subdirectory(mkdir)
add_subdirectory(readCHEMKINIII)
add_subdirectory(delete)
add_subdirectory(volField)
add_subdirectory(Field)
add_subdirectory(HashTable)
add_subdirectory(NamedEnum)
add_subdirectory(testPointEdgeWave)
add_subdirectory(CompactListList)
add_subdirectory(fileName)
add_subdirectory(cyclic)
add_subdirectory(simpleMatrix)
add_subdirectory(Map)
add_subdirectory(sort)
add_subdirectory(IStringStream)
add_subdirectory(findTimes)
add_subdirectory(prefixOSstream)
add_subdirectory(UDictionary)
add_subdirectory(FixedList)
add_subdirectory(fvc)
add_subdirectory(speed)
add_subdirectory(OStringStream)
add_subdirectory(parallel)
add_subdirectory(HashSet)
add_subdirectory(mesh)
add_subdirectory(ODETest)
add_subdirectory(graph)
add_subdirectory(dimensionedType)
add_subdirectory(nearWallDist-wave)
add_subdirectory(router)
add_subdirectory(slicedField)
add_subdirectory(DynamicList)
add_subdirectory(DynamicField)
add_subdirectory(Hashing)
add_subdirectory(HashingSpeed)
add_subdirectory(PackedList)
add_subdirectory(PackedList1)
add_subdirectory(PackedList2)
add_subdirectory(PtrList)
add_subdirectory(StaticHashTable)
add_subdirectory(UIndirectListTest)
add_subdirectory(directMappedPatch)
add_subdirectory(extendedStencil)
add_subdirectory(foamVersion)
add_subdirectory(mvBak)
add_subdirectory(regex)
add_subdirectory(sha1)
add_subdirectory(wordRe)
add_subdirectory(xfer)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== applications/utilities/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

add_subdirectory(mesh)

foam_add_app_section(util_error_est "=== Error Estimation ===")
set(FOAM_APP_SECTION util_error_est)
add_subdirectory(errorEstimation)

foam_add_app_section(util_misc "=== Miscellaneous Utilities ===")
set(FOAM_APP_SECTION util_misc)
add_subdirectory(miscellaneous)

foam_add_app_section(util_parallel "=== Parallel Processing ===")
set(FOAM_APP_SECTION util_parallel)
add_subdirectory(parallelProcessing)

add_subdirectory(postProcessing)

foam_add_app_section(util_pre_proc "=== Pre-Processing ===")
set(FOAM_APP_SECTION util_pre_proc)
add_subdirectory(preProcessing)

foam_add_app_section(util_surf "=== Surface File Manipulation ===")
set(FOAM_APP_SECTION util_surf)
add_subdirectory(surface)

foam_add_app_section(util_thermo "=== Thermophysical Utilities ===")
set(FOAM_APP_SECTION util_thermo)
add_subdirectory(thermophysical)

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== data/asciidoc/CMakeLists.txt ===
#-------------------------------------------------------------------------------
#               ______                _     ____          __  __
#              |  ____|             _| |_  / __ \   /\   |  \/  |
#              | |__ _ __ ___  ___ /     \| |  | | /  \  | \  / |
#              |  __| '__/ _ \/ _ ( (| |) ) |  | |/ /\ \ | |\/| |
#              | |  | | |  __/  __/\_   _/| |__| / ____ \| |  | |
#              |_|  |_|  \___|\___|  |_|   \____/_/    \_\_|  |_|
#
#                   FreeFOAM: The Cross-Platform CFD Toolkit
#
# Copyright (C) 2008-2012 Michael Wild <themiwi@users.sf.net>
#                         Gerber van der Graaf <gerber_graaf@users.sf.net>
#-------------------------------------------------------------------------------
# License
#   This file is part of FreeFOAM.
#
#   FreeFOAM is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by the
#   Free Software Foundation, either version 3 of the License, or (at your
#   option) any later version.
#
#   FreeFOAM is distributed in the hope that it will be useful, but WITHOUT
#   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#   for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with FreeFOAM.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------

# configure the utility data files for build tree and the install tree
foam_configure_files(installDataFiles
  DESTDIR data/asciidoc
  COPYONLY
  chunked.conf
  html.conf
  manpage.conf
  pdf.conf
  common.conf
  docbook.conf
  docbook-xsl/chunked.xsl
  docbook-xsl/common.xsl
  docbook-xsl/custom.xsl
  docbook-xsl/xhtml.xsl
  dblatex/asciidoc-dblatex.sty
  dblatex/foam-macros.sty
  dblatex/asciidoc-dblatex.xsl
  )

# install the data files
install(FILES
  ${installDataFiles}
  DESTINATION ${FOAM_INSTALL_DATA_PATH}/asciidoc
  COMPONENT dev
  )

# ------------------------- vim: set sw=2 sts=2 et: --------------- end-of-file

=== debian/changelog ===
freefoam (0.1.0+dfsg-1build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 16 Dec 2013 17:20:42 -0500

freefoam (0.1.0+dfsg-1) unstable; urgency=low

  * [92ca47f] New upstream version 0.1.0+dfsg (Closes: #682928)
  * [e07e2f1] Removed d/p/copyright.diff.
    This information belongs into debian/copyright and the CHEMKIN ckinterp.f
    file has been removed by the 0.1.0+dfsg import.
  * [300a38d] Remove DFSG-deleted directories from the build system
    - Added d/p/remove-dfsg-deleted-directories-from-build-system.diff
    - Removed d/p/userd.diff.
  * [5ff801c] Update documentation and completion scripts for DFSG-cleaning
    - Added d/p/update-for-removed-apps.diff
  * [d813ede] Added missing build-deps: graphviz (Closes: #682940)
  * [6a280d2] Fix FTBFS with GCC-4.7 because of non-qualified
    template-dependent names
    - Added d/p/missing-qualifications-of-template-dependent-names.diff
    - Removed the -fpermissive flag from CXXFLAGS.
    (Closes: #682927)
  * [a669cc7] Fix bogus lintian override
  * [a414aa0] Make debian/copyright complete, cleanup (Closes: #682942)
  * [7f41940] Fix /usr/share/freefoam/DoxyDocIndex installation, fix name
    mangling
    - Install it into freefoam-dev-doc package instead of libfreefoam-dev
    - Add d/p/doxygen-generated-file-names-breakage.diff to fix the name
      mangling issue
    - Add d/p/fix-api-doc-location.diff to fix the API documentation
      location in DoxyDocIndex.
    (Closes: #682934)
  * [c14eda9] Fix error in freefoam-log when operating on truncated log files
    - Add d/p/handle-truncated-logs-in-freefoam-log.diff
    (Closes: #682931)
  * [f35bb9c] Fix freefoam-log to create logs/ directory in the case
    directory, not $PWD
    - Added d/p/correct-output-directory-for-freefoam-log.diff
    (Closes: #682932)
  * [6de0d22] Rename the libfreefoam package to libfreefoam1
    - This is to be compliant with policy 8.2
    - Also rename the plugins0 directory to plugins1 to honour the same policy
    (Closes: 682953)
  * [d2767a3] Install *.so links into the libfreefoam-dev package, not
    libfreefoam1 (Closes: #682943)
  * [a307676] Add Michael Wild to the uploaders
  * [199ae68] Escape meta-characters before creating doc/Doxygen/filter.py
    - Added d/p/escape-meta-chars-for-doxygen-filter.diff
  * [6f94315] Fix installation dirs for template files (Closes: #683175)
  * [b5cc1ea] Install foamLog.db into the freefoam binary package
    (Closes: #683176)
  * [149cf7e] Install Doxygen CSS and image resources, update FoamHeader.html
    - In d/freefoam-dev-doc.install install the css/ and img/ folders
    - Update doc/Doxygen/FoamHeader.hmtl to Doxygen version 1.8.1.2
    (Closes: #683369)

 -- Michael Wild <themiwi@users.sourceforge.net>  Tue, 31 Jul 2012 15:32:35 +0200

freefoam (0.1.0-1)  unstable; urgency=low

   * Initial Release. Closes: #528662

 -- Gerber van der Graaf <gerber_graaf@users.sourceforge.net>  Tuesday, 28 Feb 2012 10:27:00 +0100

=== debian/control ===
Source: freefoam
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
  Gerber van der Graaf <gerber_graaf@users.sourceforge.net>,
  Michael Wild <themiwi@users.sourceforge.net>
Vcs-Git: git://git.debian.org/git/debian-science/packages/freefoam.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/freefoam.git
DM-Upload-Allowed: yes
Homepage: http://freefoam.wiki.sourceforge.net/
Build-Depends: cdbs, debhelper (>= 5.0.24), python-support, cmake, flex, 
 gawk, python, libreadline6-dev, zlib1g-dev, libscotch-dev, 
 mpi-default-dev, mpi-default-bin, paraview (>= 3.8), doxygen, 
 libjs-jquery, asciidoc, xmlto, docbook-utils, dvipng, asymptote, 
 texlive-science, dblatex, dpkg-dev (>= 1.16.1~), graphviz
Standards-Version: 3.9.3

Package: libfreefoam1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: libraries for Computational Fluid Dynamics (CFD)
 Libraries and modules for grid generation, simulation and analyzing
 of complex fluid flows. The flows may involve chemical reactions,
 turbulence, heat transfer, solid dynamics, electromagnetics and even
 the pricing of financial options. The libraries also include
 algorithms for post-processing and visualizing the resulting
 data. FreeFOAM is a fork of OpenFOAM.

Package: libfreefoam-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libfreefoam1 (= ${binary:Version}), ${python:Depends}
Description: libraries for Computational Fluid Dynamics (CFD) - development files
 Libraries and modules for grid generation, simulation and analyzing of
 complex fluid flows, post-processing and visualizing of the resulting
 data. The flows may involve chemical reactions, turbulence, heat
 transfer, solid dynamics, electromagnetics and even the pricing of
 financial options. FreeFOAM is a fork of OpenFOAM.
 .
 This package contains static linked libraries, headers and templates

Package: freefoam
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, 
  libfreefoam1 (= ${binary:Version}), mpi-default-bin, 
  tcsh | csh | c-shell, ${python:Depends}
Description: programs for Computational Fluid Dynamics (CFD)
 A collection of solvers and utility programs for grid generation,
 simulation and analyzing of complex fluid flows, post-processing and
 visualizing of the resulting data. The flows may involve chemical
 reactions, turbulence and heat transfer, solid dynamics,
 electromagnetics and even the pricing of financial options. FreeFOAM
 is a fork of OpenFOAM.
 .
 The programs are invoked with "freefoam foo".

Package: freefoam-user-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: python
Description: software for Computational Fluid Dynamics - user documentation
 Tutorials and user documentation for a collection of programs for
 grid generation, simulation and analyzing of complex fluid flows,
 post-processing and visualizing of the resulting data. The flows may
 involve chemical reactions, turbulence and heat transfer, solid
 dynamics, electromagnetics and even the pricing of financial
 options. FreeFOAM is a fork of OpenFOAM.

Package: freefoam-dev-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: python
Description: software for Computational Fluid Dynamics - developers documentation
 Library references and developers documentation for a collection of
 programs for grid generation, simulation and analyzing of complex
 fluid flows, post-processing and visualizing of the resulting data. The
 flows may involve chemical reactions, turbulence and heat transfer,
 solid dynamics, electromagnetics and even the pricing of financial
 options. FreeFOAM is a fork of OpenFOAM.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Injecting CPPFLAGS:
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CXXFLAGS+=$(CPPFLAGS) -fpermissive

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

 
export OMPI_MCA_plm_rsh_agent=/bin/false

FF_SUBDIR=freefoam


FF_CONFIG_THIRD_PARTY=					\
	-DFOAM_BUILD_PRIVATE_METIS=OFF			\
	-DFOAM_BUILD_PRIVATE_PARMETIS=OFF		\
	-DFOAM_BUILD_PRIVATE_SCOTCH=OFF			\
	-DFOAM_BUILD_PRIVATE_ZLIB=OFF

FF_CONFIG_PACK=						\
	-DCPACK_BINARY_DEB=OFF				\
	-DCPACK_BINARY_NSIS=OFF				\
	-DCPACK_BINARY_RPM=OFF				\
	-DCPACK_BINARY_STGZ=OFF				\
	-DCPACK_BINARY_TBZ2=OFF				\
	-DCPACK_BINARY_TGZ=OFF				\
	-DCPACK_BINARY_TZ=OFF				\
	-DCPACK_SOURCE_TBZ2=OFF				\
	-DCPACK_SOURCE_TGZ=OFF				\
	-DCPACK_SOURCE_TZ=OFF				\
	-DCPACK_SOURCE_ZIP=OFF				\

FF_DOC=							\
	-DFOAM_ENABLE_PDF_GUIDES=ON			\
	-DFOAM_ENABLE_XHTML_GUIDES=OFF			\
	-DFOAM_ENABLE_XHTML_HELP=OFF			\
	-DFOAM_ENABLE_MATHJAX=OFF			\
	-DFOAM_ENABLE_DOXYGEN_DOCS=ON			\
	-DFOAM_ENABLE_MANPAGE_HELP=OFF			\
	-DFOAM_DOCS_FOR_SF=OFF				\

FF_INSTALL=								\
	-DFOAM_INSTALL_BIN_PATH=/usr/bin				\
	-DFOAM_INSTALL_CMAKE_PATH=/usr/share/$(FF_SUBDIR)/CMake		\
	-DFOAM_INSTALL_CONFIG_PATH=/etc/$(FF_SUBDIR)			\
	-DFOAM_INSTALL_DATA_PATH=/usr/share/$(FF_SUBDIR)		\
	-DFOAM_INSTALL_DOC_PATH=/usr/share/doc/$(FF_SUBDIR)		\
	-DFOAM_INSTALL_HEADER_PATH=/usr/include/$(FF_SUBDIR)		\
	-DFOAM_INSTALL_LIBEXEC_PATH=/usr/bin				\
	-DFOAM_INSTALL_LIBRARY_PATH=/usr/lib/$(FF_SUBDIR)		\
	-DFOAM_INSTALL_MAN_PATH=/usr/share/man				\
	-DFOAM_INSTALL_PLUGIN_PATH=/usr/lib/$(FF_SUBDIR)/plugins1	\
	-DFOAM_INSTALL_TUTORIALS_PATH=/usr/share/doc/$(FF_SUBDIR)	\
	-DFOAM_INSTALL_USERDFOAM_PATH=/usr/lib/$(FF_SUBDIR)/plugins1/ensightReader

DEB_CMAKE_EXTRA_FLAGS= 					\
	-DFOAM_EXE_PREFIX=freefoam-			\
	-DFOAM_ENABLE_METIS=OFF				\
	-DFOAM_ENABLE_MGRIDGEN=OFF			\
	-DFOAM_USE_MPI=ON				\
	-DFOAM_DEFAULT_PSTREAM=mpi			\
	-DFOAM_DOUBLE_PRECISION=ON			\
	-DFOAM_ENABLE_PARMETIS=OFF			\
	-DCMAKE_SKIP_RPATH=OFF				\
	-DFOAM_ENABLE_CCMIO=OFF				\
        -DBUILD_TESTING=OFF				\
	-DFOAM_ENABLE_FULL_TUTORIAL_TEST=OFF		\
	$(FF_CONFIG_THIRD_PARTY)			\
	$(FF_DOC)					\
	$(FF_INSTALL)



DEB_DH_MAKESHLIBDEPS_ARGS_libfreefoam1=-X/usr/lib/$(FF_SUBDIR)


install/libfreefoam1::
	install -d $(CURDIR)/debian/libfreefoam1/usr/lib/$(FF_SUBDIR)

install/libfreefoam-dev::
	install -d $(CURDIR)/debian/libfreefoam-dev/usr/include/$(FF_SUBDIR)
	install -d $(CURDIR)/debian/libfreefoam-dev/usr/share/$(FF_SUBDIR)
	rm $(CURDIR)/debian/tmp/usr/share/$(FF_SUBDIR)/templates/foamScript

install/freefoam::
	install -d $(CURDIR)/debian/freefoam/usr/bin
	install -d $(CURDIR)/debian/freefoam/usr/share/man/man1
	install -d $(CURDIR)/debian/freefoam/etc/freefoam
	install -d $(CURDIR)/debian/freefoam/etc/bash_completion.d
	cp $(CURDIR)/data/shellFunctions/bashCompletion/freefoam $(CURDIR)/debian/freefoam/etc/bash_completion.d/

install/freefoam-user-doc::
	install -d $(CURDIR)/debian/freefoam-user-doc/usr/share/doc/freefoam-user-doc/tutorials
	rm $(CURDIR)/debian/tmp/usr/share/doc/freefoam/tutorials/multiphase/interFoam/les/nozzleFlow2D/0/data/Ubulk
	rm $(CURDIR)/debian/tmp/usr/share/doc/freefoam/tutorials/multiphase/interFoam/les/nozzleFlow2D/0/data/ptrace
	rmdir $(CURDIR)/debian/tmp/usr/share/doc/freefoam/tutorials/multiphase/interFoam/les/nozzleFlow2D/0/data

install/freefoam-dev-doc::
	rm $(CURDIR)/debian/tmp/usr/share/doc/freefoam/API/jquery.js

binary-install/libfreefoam1::
	dh_pysupport -plibfreefoam1

binary-install/libfreefoam-dev::
	dh_pysupport -plibfreefoam-dev

binary-install/freefoam::
	dh_pysupport -pfreefoam

=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg\.\d+$// \
http://sf.net/freefoam/freefoam-([\d.]*)\.tar\.bz2 debian uupdate
